﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace klientMesic
{
    public partial class Form1 : Form
    {
        private string vychoziAdresa = "http://localhost:8000";
        private Pristani prist;

        public Form1()
        {
            InitializeComponent();

            //Pro autopilota
            string[] args = Environment.GetCommandLineArgs();
            if (args.Length >= 2)
            {
                string url = args[1];
                //int omezeni = int.Parse(args[2]);

                prist = new Pristani(url, canvas, true);
                prist.AutoPilot();

            }
        }

        private void canvas_Paint(object sender, PaintEventArgs e)
        {
            if (prist != null)
            {
                prist.Vykresli(e.Graphics);
                prist.ZobrazStav(dolevaImg, nahoruImg, dopravaImg, palivoBar, rychlostXLbl, rychlostYLbl);
            }
        }


        private void uzivatelBtn_Click(object sender, EventArgs e)
        {
            string url = serverBox.Text;
            if (url == "")
            {
                url = vychoziAdresa;
            }
            prist = new Pristani(url, canvas, false);
            palivoBar.Maximum = (int)prist.p;
            palivoBar.Value = (int)prist.p;
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (prist != null)
            {
                if (!prist.jeAutoPilot)
                {
                    switch (e.KeyCode)
                    {
                        case Keys.Left:
                            prist.motorDoleva = true;
                            prist.Posli("doleva=1");
                            break;
                        case Keys.Up:
                            prist.motorNahoru = true;
                            prist.Posli("nahoru=1");
                            break;
                        case Keys.Right:
                            prist.motorDoprava = true;
                            prist.Posli("doprava=1");
                            break;
                    }
                }
            }
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            if (prist != null)
            {
                if (!prist.jeAutoPilot)
                {
                    switch (e.KeyCode)
                    {
                        case Keys.Left:
                            prist.motorDoleva = false;
                            prist.Posli("doleva=0");
                            break;
                        case Keys.Up:
                            prist.motorNahoru = false;
                            prist.Posli("nahoru=0");
                            break;
                        case Keys.Right:
                            prist.motorDoprava = false;
                            prist.Posli("doprava=0");
                            break;
                    }
                }
            }
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            if (prist != null)
            {
                prist.Pohyb();
                canvas.Refresh();
                if (prist.jeAutoPilot)
                {
                    prist.AutoPilot();
                }
            }
        }

        private void dolevaImg_Click(object sender, EventArgs e)
        {
            if (prist != null)
            {
                if (!prist.jeAutoPilot)
                {
                    prist.motorDoleva = !prist.motorDoleva;
                    if (prist.motorDoleva)
                    {
                        prist.Posli("doleva=1");
                    }
                    else
                    {
                        prist.Posli("doleva=0");
                    }
                }
            }
        }

        private void nahoruImg_Click(object sender, EventArgs e)
        {
            if (prist != null)
            {
                if (!prist.jeAutoPilot)
                {
                    prist.motorNahoru = !prist.motorNahoru;
                    if (prist.motorNahoru)
                    {
                        prist.Posli("nahoru=1");
                    }
                    else
                    {
                        prist.Posli("nahoru=0");
                    }
                }
            }
        }

        private void dopravaImg_Click(object sender, EventArgs e)
        {
            if (prist != null)
            {
                if (!prist.jeAutoPilot)
                {
                    prist.motorDoprava = !prist.motorDoprava;
                    if (prist.motorDoprava)
                    {
                        prist.Posli("doprava=1");
                    }
                    else
                    {
                        prist.Posli("doprava=0");
                    }
                }
            }
        }

        private void autopilotBtn_Click(object sender, EventArgs e)
        {
            string url = serverBox.Text;
            if (url == "")
            {
                url = vychoziAdresa;
            }
            prist = new Pristani(url, canvas, true);
            palivoBar.Maximum = (int)prist.p;
            palivoBar.Value = (int)prist.p;
        }
    }
}
